/*
 * Copyright (C) Paul Räber 2011
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package ch.praeber.humigraf.system;

import java.util.Locale;

/**
 * Fahrenheit
 * Version 1.0.0
 * Class adding C or F
 * @author Meier Philipp <meier.phi@gmail.com>
 *
 */
public class Fahrenheit {

    /**
     * Adds °C or °F to the String
     * @param temperature Temperature String
     * @return String of temperature with one of the si units
     */
    public static String addSIUnit(String temperature) {
        Locale locale = Locale.getDefault();
        if (locale.equals(Locale.US)) {
            return temperature + " °F";
        } else {
            return temperature + " °C";
        }
    }

    /**
     *
     * @return
     */
    public static String getSIUnit() {
        Locale locale = Locale.getDefault();
        if (locale.equals(Locale.US)) {
            return "°F";
        } else {
            return "°C";
        }

    }

    /**
     * Tranform Celsius to Fahrenheit
     * @param Celsius
     * @return Fahrenheit
     */
    public static double toFahrenheit(double Celsius) {
        return 32 + (9 * Celsius) / 5;

    }
}
