/*
 * Copyright (C) Paul Räber 2011
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package ch.praeber.humigraf.system;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/**
 * Filehandling
 * Version 1.0.0
 * Writing data to binary files or loading that file
 * @author Meier Philipp <meier.phi@gmail.com>
 *
 */
public class FileHandling {

    public void FileHandling() {
    }

    /**
     * Write a binary file with objects
     *
     * @return  true:   write a file was sucessfully
     *          false:  write a file was aborted/unsucessfully
     */
    public static boolean writeBinFile(File aFile, Object[] objects) {

        File file = aFile;
        Object[] data = objects;

        if (file != null) {

            if (file.canWrite() || !file.exists()) {

                try {
                    FileOutputStream aFileOutputStream =
                            new FileOutputStream(file);

                    ObjectOutputStream aObjectOutputStream =
                            new ObjectOutputStream(aFileOutputStream);

                    // Write start
                    aObjectOutputStream.writeObject("P-Raeber Analytics - start >>>");

                    for (int i = 0; i < data.length; i++) {

                        aObjectOutputStream.writeObject(data[i]);

                    }

                    // Write end
                    aObjectOutputStream.writeObject("<<< end - P-Raeber Analytics");

                    aFileOutputStream.close();

                } catch (IOException e) {
                    System.out.println("Unknown operation occured.");
                    return false;
                }

                return true;

            } else {
                System.out.println("File locked.");
                return false;
            }
        } else {
            return false;
        }
    }

    /**
     * Read a file
     *
     * @return  true:   read a file was sucessfully
     *          false:  read a file was aborted/unsucessfully
     */
    public static Object[] readBinFile(String aFileAbsolutePath) {
        String fileAbsolutePath = aFileAbsolutePath;
        Object[] dataObjects = new Object[1];
        File file;

        if (fileAbsolutePath != null) {

            file = new File(fileAbsolutePath);

            if (file.exists()) {

                try {

                    FileInputStream aFileInputStream =
                            new FileInputStream(file);
                    //DataInputStream aDataInputStream =
                    //new DataInputStream(aFileInputStream);
                    ObjectInputStream aObjectInputStream =
                            new ObjectInputStream(aFileInputStream);

                    // Read start
                    String fileStartDefinition = (String) aObjectInputStream.readObject();
                    if (!fileStartDefinition.equals("P-Raeber Analytics - start >>>")) {
                        return null;
                    }

                    dataObjects[0] = aObjectInputStream.readObject();
                    //  dataObjects[1] = aObjectInputStream.readObject();
                    //  dataObjects[2] = aObjectInputStream.readObject();

                    // Read end
                    String fileEndDefinition = (String) aObjectInputStream.readObject();
                    if (!fileEndDefinition.equals("<<< end - P-Raeber Analytics")) {
                        return null;
                    }

                    aFileInputStream.close();

                } catch (IOException e) {
                    System.out.println("Unknown operation occured.");
                    return null;
                } catch (ClassNotFoundException e) {
                    System.out.println("Unknown operation occured.");
                    return null;
                }

                return dataObjects;

            } else {
                System.out.println("File doesn't exist.");
                return null;
            }
        } else {
            return null;
        }
    }
}
